diff --git a/isisd/isis_tlvs.c b/isisd/isis_tlvs.c
index 8bf719470470..4a7005b305e9 100644
--- a/isisd/isis_tlvs.c
+++ b/isisd/isis_tlvs.c
@@ -2176,6 +2176,10 @@ static void format_item_srv6_end_sid(uint16_t mtid, struct isis_item *i,
 
 static void free_item_srv6_end_sid(struct isis_item *i)
 {
+	struct isis_srv6_end_sid_subtlv *item =
+		(struct isis_srv6_end_sid_subtlv *)i;
+
+	isis_free_subsubtlvs(item->subsubtlvs);
 	XFREE(MTYPE_ISIS_SUBTLV, i);
 }
 
